package com.casic.dcms.ui.fragment.handle;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.casic.dcms.adapter.CaseHandleAdapter;
import com.casic.dcms.base.AndroidxBaseFragment;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.CaseHandleBean;
import com.casic.dcms.databinding.FragmentHandleCaseBinding;
import com.casic.dcms.mvp.presenter.impl.CaseListHandlePresenterImpl;
import com.casic.dcms.mvp.view.ICaseListHandleView;
import com.casic.dcms.ui.CaseHandleDetailActivity;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.ToastHelper;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class UrgentCaseFragment extends AndroidxBaseFragment<FragmentHandleCaseBinding> implements ICaseListHandleView {

    private static final String TAG = "UrgentCaseFragment";
    private Context context;
    private int pageIndex = 1;
    private List<CaseHandleBean.DataBean.RowsBean> dataBeans = new ArrayList<>();
    private boolean isRefresh, isLoadMore = false;
    private CaseListHandlePresenterImpl caseHandleListPresenter;
    private CaseHandleAdapter adapter;
    private static WeakReferenceHandler weakReferenceHandler;

    @Override
    protected void setupTopBarLayout() {
        context = getContext();
    }

    @Override
    protected void initData() {
        caseHandleListPresenter = new CaseListHandlePresenterImpl(this);
        /**
         * isOvertime	否	String	是否超时,null-所有案卷,1-超时案卷
         * isEmergent	否	String	是否紧急,null-所有案卷,1-紧急案卷
         */
        caseHandleListPresenter.onReadyRetrofitRequest(null, "1", Constant.PAGE_LIMIT, pageIndex);

        weakReferenceHandler = new WeakReferenceHandler(this);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                pageIndex = 1;
                caseHandleListPresenter.onReadyRetrofitRequest(null, "1", Constant.PAGE_LIMIT, pageIndex);
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                caseHandleListPresenter.onReadyRetrofitRequest(null, "1", Constant.PAGE_LIMIT, pageIndex);
            }
        });
    }

    /**
     * 供{@link com.casic.dcms.ui.CaseHandleDetailActivity#obtainCaseHandleResult(ActionResultBean)}调用
     */
    public static void sendEmptyMessage(int what) {
        if (weakReferenceHandler == null) {
            return;
        }
        weakReferenceHandler.sendEmptyMessage(what);
    }

    private static class WeakReferenceHandler extends Handler {
        private final WeakReference<UrgentCaseFragment> reference;

        private WeakReferenceHandler(UrgentCaseFragment fragment) {
            reference = new WeakReference<>(fragment);
        }

        @Override
        public void handleMessage(Message msg) {
            UrgentCaseFragment urgentCaseFragment = reference.get();
            if (msg.what == Constant.CASE_HANDLE_OK) {
                Log.d(TAG, "紧急案卷处理成功，更新列表");
                urgentCaseFragment.isRefresh = true;
                //刷新之后页码重置
                urgentCaseFragment.pageIndex = 1;
                urgentCaseFragment.caseHandleListPresenter.onReadyRetrofitRequest(null, "1", Constant.PAGE_LIMIT, urgentCaseFragment.pageIndex);
            } else if (msg.what == 202104286) {
                if (urgentCaseFragment.isRefresh || urgentCaseFragment.isLoadMore) {
                    urgentCaseFragment.adapter.notifyDataSetChanged();
                } else {
                    //首次加载数据
                    if (urgentCaseFragment.dataBeans.size() == 0) {
                        urgentCaseFragment.viewBinding.emptyView.show("没有案卷需要处理", null);
                    } else {
                        urgentCaseFragment.viewBinding.emptyView.hide();
                        urgentCaseFragment.adapter = new CaseHandleAdapter(urgentCaseFragment.context, urgentCaseFragment.dataBeans);
                        urgentCaseFragment.viewBinding.caseRecyclerView.setLayoutManager(new LinearLayoutManager(urgentCaseFragment.context));
                        urgentCaseFragment.viewBinding.caseRecyclerView.addItemDecoration(new DividerItemDecoration(urgentCaseFragment.context, DividerItemDecoration.VERTICAL));
                        urgentCaseFragment.viewBinding.caseRecyclerView.setAdapter(urgentCaseFragment.adapter);
                        urgentCaseFragment.adapter.setOnItemClickListener(new CaseHandleAdapter.OnItemClickListener() {
                            @Override
                            public void onClick(int position) {
                                Intent intent = new Intent(urgentCaseFragment.context, CaseHandleDetailActivity.class);
                                intent.putExtra("title", "紧急案卷");
                                intent.putExtra("id", urgentCaseFragment.dataBeans.get(position).getId());
                                urgentCaseFragment.startActivity(intent);
                            }
                        });
                    }
                }
            }
        }
    }

    @Override
    public void obtainCaseHandleList(CaseHandleBean resultBean) {
//        Log.d(TAG, "obtainUrgentCaseList: " + new Gson().toJson(resultBean));
        if (resultBean.isSuccess()) {
            List<CaseHandleBean.DataBean.RowsBean> dataRows = resultBean.getData().getRows();
            if (isRefresh) {
                dataBeans.clear();//下拉刷新必须先清空之前的List，不然会出现数据重复的问题
                dataBeans = dataRows;
                viewBinding.refreshLayout.finishRefresh();
                isRefresh = false;
            } else if (isLoadMore) {
                if (dataRows.size() == 0) {
                    ToastHelper.showToast("到底了，别拉了", ToastHelper.INFO);
                }
                dataBeans.addAll(dataRows);
                viewBinding.refreshLayout.finishLoadMore();
                isLoadMore = false;
            } else {
                dataBeans = dataRows;
            }
            weakReferenceHandler.sendEmptyMessage(202104286);
        }
    }

    @Override
    public void onDestroyView() {
        if (caseHandleListPresenter != null) {
            caseHandleListPresenter.disposeRetrofitRequest();
        }
        super.onDestroyView();
    }
}
